	xdef	_SetupParPort
	xdef	_SetVolume
	xdef	_SetPrefactor
	xdef	_SetBass
	xdef	_SetTreble

	xref	_GFXBase

_SetupParPort
;Set the parallel port hardware up

	MOVE.B  #%00000000,$bfd200
	MOVE.B  #%00000011,$bfe101
	MOVE.B  #%00010011,$bfe301		; Reset on
	MOVE.B  #%00000011,$bfe301		; Reset off
	MOVE.B  #%00000011,$bfe101

	lea		$bfe301,a1
	bsr		Write_IIC_S
	move.b	#$3A,d0
	bsr		Write_IIC_D0
	move.b	#$68,d0
	bsr		Write_IIC_D0
	move.b	#$93,d0
	bsr		Write_IIC_D0
	move.b	#$b0,d0
	bsr		Write_IIC_D0
	move.b	#$00,d0
	bsr		Write_IIC_D0
	move.b	#$02,d0
	bsr		Write_IIC_D0
	bsr		Write_IIC_P
	bsr		Write_IIC_S
	move.b	#$3A,d0
	bsr		Write_IIC_D0
	move.b	#$68,d0
	bsr		Write_IIC_D0
	move.b	#$00,d0
	bsr		Write_IIC_D0
	move.b	#$01,d0
	bsr		Write_IIC_D0
	bsr		Write_IIC_P
	
	rts

_SetVolume
;Set the overall volume level
;d0 - volume left
;d1 - volume right

  MOVE.l   d5,-(a7)

	move.l	d1,d5

  MOVE.l  d0,d2
  MOVE.w  d2,d3
  LSR.w   #8,d3
  MOVE.l  d2,d4
  SWAP    d4

  LEA     $BFE301,A1
VolumeS_LL
  BSR     Write_IIC_S
  MOVE.B  #$3A,D0
  BSR     Write_IIC_D0
  MOVE.B  #$68,D0
  BSR     Write_IIC_D0
  MOVE.B  #$B0,D0
  BSR     Write_IIC_D0
  MOVE.B  #$00,D0
  BSR     Write_IIC_D0
  MOVE.B  #$00,D0
  BSR     Write_IIC_D0
  MOVE.B  #$01,D0
  BSR     Write_IIC_D0
  MOVE.B  #$07,D0
  BSR     Write_IIC_D0
  MOVE.B  #$F8,D0
  BSR     Write_IIC_D0
  MOVE.B  D3,D0
  BSR     Write_IIC_D0
  MOVE.B  D2,D0
  BSR     Write_IIC_D0
  MOVE.B  #$00,D0
  BSR     Write_IIC_D0
  MOVE.B  D4,D0
  BSR     Write_IIC_D0
  BSR     Write_IIC_P

  MOVE.l  d5,d2
  MOVE.w  d2,d3
  LSR.w   #8,d3
  MOVE.l  d2,d4
  SWAP    d4

VolumeS_RR
  BSR     Write_IIC_S
  MOVE.B  #$3A,D0
  BSR     Write_IIC_D0
  MOVE.B  #$68,D0
  BSR     Write_IIC_D0
  MOVE.B  #$B0,D0
  BSR     Write_IIC_D0
  MOVE.B  #$00,D0
  BSR     Write_IIC_D0
  MOVE.B  #$00,D0
  BSR     Write_IIC_D0
  MOVE.B  #$01,D0
  BSR     Write_IIC_D0
  MOVE.B  #$07,D0
  BSR     Write_IIC_D0
  MOVE.B  #$FB,D0
  BSR     Write_IIC_D0
  MOVE.B  D3,D0
  BSR     Write_IIC_D0
  MOVE.B  D2,D0
  BSR     Write_IIC_D0
  MOVE.B  #$00,D0
  BSR     Write_IIC_D0
  MOVE.B  D4,D0
  BSR     Write_IIC_D0
  BSR     Write_IIC_P

;  BRA     iic_exit

	move.l	(a7)+,d5

	rts

_SetPrefactor
;d0 - prefactor level

;  MOVEM   d0-d7/a0-a6,-(a7)

  MOVE.w  d0,d2
  MOVE.w  d2,d3
  LSR.w   #8,d3

  LEA     $BFE301,A1
  BSR     Write_IIC_S
  MOVE.b  #$3a,d0
  BSR     Write_IIC_D0
  MOVE.b  #$68,d0
  BSR     Write_IIC_D0
  MOVE.b  #$9E,d0
  BSR     Write_IIC_D0
  MOVE.b  #$70,d0
  BSR     Write_IIC_D0
  MOVE.b  d3,d0
  BSR     Write_IIC_D0
  MOVE.b  d2,d0
  BSR     Write_IIC_D0
  BSR     Write_IIC_P

;  BRA     iic_exit
	rts

_SetBass
;d0 - bass

;	MOVEM   d0-d7/a0-a6,-(a7)
	move.b	#$b0,d4
	jmp		go

_SetTreble
;d0 - treble

;	MOVEM   d0-d7/a0-a6,-(a7)
	move.b	#$f0,d4

go

  MOVE.w  d0,d2
  MOVE.w  d2,d3
  LSR.w   #8,d3

  LEA     $BFE301,A1
  BSR     Write_IIC_S
  MOVE.b  #$3a,d0
  BSR     Write_IIC_D0
  MOVE.b  #$68,d0
  BSR     Write_IIC_D0
  MOVE.b  #$96,d0
  BSR     Write_IIC_D0
  MOVE.b  d4,d0
  BSR     Write_IIC_D0
  MOVE.b  d3,d0
  BSR     Write_IIC_D0
  MOVE.b  d2,d0
  BSR     Write_IIC_D0
  BSR     Write_IIC_P

;  BRA     iic_exit
	rts



Write_IIC_S
  BSR     Wait_IIC
  MOVE.B  #%00000011,(a1)
;  BSR     Wait_IIC
  MOVE.B  #%00001011,(a1)
;  BSR     Wait_IIC
  MOVE.B  #%00001111,(a1)
  RTS

Write_IIC_P
  BSR     Wait_IIC
  MOVE.B  #%00001111,(a1)
;  BSR     Wait_IIC
  MOVE.B  #%00001011,(a1)
;  BSR     Wait_IIC
  MOVE.B  #%00000011,(a1)
  RTS

Write_IIC_1
;  BSR     Wait_IIC
;  MOVE.B  #%00001111,(a1)
  BSR     Wait_IIC
  MOVE.B  #%00000111,(a1)
  BSR     Wait_IIC
  MOVE.B  #%00000011,(a1)
  BSR     Wait_IIC
  MOVE.B  #%00000111,(a1)
;  BSR     Wait_IIC
;  MOVE.B  #%00001111,(a1)
  RTS

Write_IIC_0
;  BSR     Wait_IIC
;  MOVE.B  #%00001111,(a1)
  BSR     Wait_IIC
  MOVE.B  #%00001111,(a1)
  BSR     Wait_IIC
  MOVE.B  #%00001011,(a1)
  BSR     Wait_IIC
  MOVE.B  #%00001111,(a1)
;  BSR     Wait_IIC
;  MOVE.B  #%00001111,(a1)
  RTS

Write_IIC_D0
	Moveq.L	#9,D1
Write_Loop
	Subq.B	#1,D1
	Beq.b	Write_IIC_0
	Rol.B	#1,D0
	Btst	#0,D0
	Beq.b	Write_0
	Bsr.b	Write_IIC_1
	Bra.b	Write_Loop
Write_0
	Bsr.b	Write_IIC_0
	Bra.b	Write_Loop

;Wait_IIC
;  MOVEM.L D0-D1,-(SP)
;  MOVE.L  #40,d0
;wicloop
;;  MOVE.B  $bfe301,d1
;  move.b  $bfd200,d1
;  DBRA    D0,wicloop
;  MOVEM.L (SP)+,D0-D1
;  RTS
  
Wait_IIC
	MOVEM.L	D0-D1/A1,-(A7)
;	MOVEA.L	(A1),A6
	MOVE.L	_GFXBase,A6
	JSR		-384(A6)
	MOVE.L	D0,D7
LAB_0198:
;	MOVEA.L	(A1),A6
	MOVE.L	_GFXBase,A6
	JSR		-384(A6)
	CMP.L		D0,D7
	BEQ.S		LAB_0198
	MOVEM.L	(A7)+,D0-D1/A1
	RTS